Index: trunk/src/ProcessManagement/ProcessManagement/Forms/ZMenu/FrmMenuAuxiliary.cs
===================================================================
--- trunk/src/ProcessManagement/ProcessManagement/Forms/ZMenu/FrmMenuAuxiliary.cs	(revision 7)
+++ trunk/src/ProcessManagement/ProcessManagement/Forms/ZMenu/FrmMenuAuxiliary.cs	(revision 8)
@@ -158,6 +158,10 @@
                         DispConstructionProjects();
                         btnDataCopyE.Visible = true;
                         break;
+                    case (int)FrmMenuTabNameEnum.FluctuationProjects:
+                        // 増減工事状況一覧表示
+                        DispFluctuationProjects();
+                        break;
                     case (int)FrmMenuTabNameEnum.NonOrders:
                         // 非受注一覧
                         SetInitNumUDData(numUDNonOrder);        // 営業期選択ボックス初期設定
@@ -1010,6 +1014,38 @@
         #endregion
 
         #region 案件表示データ共通部
+        #region 表示用共通部SQL増減工事フラグ部作成
+        /// <summary>
+        /// 表示用共通部SQL増減工事フラグ部作成
+        /// </summary>
+        /// <param name="Status">パラメータリスト</param>
+        /// <param name="EstimateType">見積種別検索</param>
+        /// <returns></returns>
+        private string CreateListSQLFluctuation(bool FluctuationType = false)
+        {
+            string strSQL = string.Empty;
+            try
+            {
+                if (FluctuationType)
+                {
+                    strSQL += string.Format(" Where TyingFlg = {0}", (int)CommonDefine.BaseInfoTyingFlg.Tying);
+                }
+                else
+                {
+                    strSQL += string.Format(" Where TyingFlg != {0}", (int)CommonDefine.BaseInfoTyingFlg.Tying);
+                }
+                strSQL += " AND (";
+
+                return strSQL;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}：{2}", CommonMotions.GetMethodName(), ex.Message, strSQL);
+                return string.Empty;
+            }
+        }
+        #endregion
+
         #region 表示用共通部SQL作成
         /// <summary>
         /// 表示用共通部SQL作成
@@ -1022,10 +1058,6 @@
             string strSQL = string.Empty;
             try
             {
-                strSQL += string.Format(" Where TyingFlg != {0}", (int)CommonDefine.BaseInfoTyingFlg.Tying);
-                strSQL += " AND";
-                strSQL += " (";
-
                 if (EstimateType)
                 {
                     // 依頼受け・見積提出は通常見積・入札物件・予算取り物件を分ける
@@ -1218,6 +1250,8 @@
             C_PERSONNAME,
             STARTDATE,
             ENDDATE,
+            ApprovalCode,
+            ApprovalSTatus,
         }
         #endregion
 
@@ -1229,15 +1263,20 @@
         {
             ClsSystemOnceExecute ChkProc = new ClsSystemOnceExecute();
             IOConstructionBaseInfo cbiDB = new IOConstructionBaseInfo();
-            dgvSalesInProjects.SuspendLayout();
+            DataGridViewEX dgv = dgvSalesInProjects;
             try
             {
-                dgvSalesInProjects.Rows.Clear();
+                dgv.SuspendLayout();
+                dgv.Rows.Clear();
                 // SQL作成
                 string strSQL = "SELECT A.ConstructionCode, A.ConstructionPeriod, B.DETAILNO, B.DETAILSTRING, A.ConstructionStatusFlg,";
-                strSQL += " A.EstimatesSubmitDeadline, C.PERSONNAME, D.PERSONNAME, A.STARTDATE, A.ENDDATE, A.* ";
-                strSQL += " FROM CONSTRUCTIONBASEINFO A LEFT JOIN  PERSONINCHARGEMASTER D  ON D.PERSONCODE = A.CONSTRUCTIONPERSONCODE,";
-                strSQL += " CONSTRUCTIONBASEINFODETAIL B , PERSONINCHARGEMASTER C";
+                strSQL += " A.EstimatesSubmitDeadline, C.PERSONNAME, D.PERSONNAME, A.STARTDATE, A.ENDDATE, G.APPROVALCODE, NVL(G.APPROVALSTATUS, -1), A.*";
+                strSQL += " FROM CONSTRUCTIONBASEINFO A";
+                strSQL += " LEFT JOIN  PERSONINCHARGEMASTER D ON D.PERSONCODE = A.CONSTRUCTIONPERSONCODE";
+                strSQL += " LEFT JOIN (SELECT SG.CONSTRUCTIONCODE, SG.SEQNO, SG.APPROVALSTATUS, MAX(SG.APPROVALCODE) APPROVALCODE";
+                strSQL += " FROM PROCESSAPPROVAL SG GROUP BY SG.CONSTRUCTIONCODE, SG.SEQNO, SG.APPROVALSTATUS) G";
+                strSQL += " ON A.ConstructionCode = G.CONSTRUCTIONCODE AND G.SEQNO = 1";
+                strSQL += ", CONSTRUCTIONBASEINFODETAIL B, PERSONINCHARGEMASTER C";
 
                 strSQL += CreateSalesInProjectsSQL();
                 strSQL += string.Format(" AND B.CONSTRUCTIONCODE = A.CONSTRUCTIONCODE AND B.DETAILNO <= {0}", (int)ConstructionBaseInfoDetail.DetailDataNo.ConstructionPlace3);
@@ -1284,7 +1323,13 @@
                     DateTime dStartDate = CommonMotions.cnvDate(wrkRec[(int)DBColumn1.STARTDATE]);
                     DateTime dEndDate = CommonMotions.cnvDate(wrkRec[(int)DBColumn1.ENDDATE]);
 
+                    int iApprovalCode = CommonMotions.cnvInt(wrkRec[(int)DBColumn1.ApprovalCode]);
+                    string sApprovalName = string.Empty;
+                    if (iApprovalCode != 0) sApprovalName = ClsExcute.AppovalList[iApprovalCode];
+                    int iApprovalStatus = CommonMotions.cnvInt(wrkRec[(int)DBColumn1.ApprovalSTatus]);
+
                     if (iConstructionCode == BreakConstructionCode) continue;
+
                     // 名称取得
                     getDetailStrings(iConstructionCode, arData, ref Details);
 
@@ -1293,16 +1338,17 @@
                     if (BreakConstructionPeriod != iConstructionPeriod)
                     {
                         BreakConstructionPeriod = iConstructionPeriod;
-                        dgvSalesInProjects.Rows.Add();
+                        dgv.Rows.Add();
                         iLineCnt++;
                     }
 
                     // データセット
-                    int LineCnt = dgvSalesInProjects.Rows.Add(iConstructionCode
+                    int LineCnt = dgv.Rows.Add(iConstructionCode
                                                 , ino
                                                 , iConstructionPeriod
                                                 , Details[0]
                                                 , CommonDefine.ProjectsStatus[iConstructionStatusFlg]
+                                                , sApprovalName
                                                 , CommonMotions.cnvDateToUndecidedString(dEstimatesSubmitDeadline)
                                                 , salesname
                                                 , constructorname
@@ -1310,7 +1356,6 @@
                                                 , CommonMotions.cnvDateToUndecidedString(dEndDate)
                                                 , Details[1] + Details[2] + Details[3]
                                                 , Details[4]);
-                                                //, Details[4]});
 
                     // データを工事情報のフォーマットに詰めなおす
                     ConstructionBaseInfo BaseRec = new ConstructionBaseInfo();
@@ -1323,18 +1368,22 @@
                     cbiDB.Reader2Struct(wrkobj, ref BaseRec);
 
                     // エラー行に色を付ける
-                    DataGridViewRow row = dgvSalesInProjects.Rows[LineCnt];
-                    DispErrorSubmittedDateRow(dgvSalesInProjects, row, BaseRec, ChkProc);
+                    DataGridViewRow row = dgv.Rows[LineCnt];
+                    DispErrorSubmittedDateRow(dgv, row, BaseRec, ChkProc);
                     iLineCnt++;
 
+                    // 承認状態に色を付ける
+                    DataGridViewCell CurCell = dgv.Rows[LineCnt].Cells[(int)MenuGridCount.ConstrApproval];
+                    SetCellApprovalColor(CurCell, iApprovalCode, iApprovalStatus);
+
                     // ProgressBarの値を変更する
                     ProgressSalesProjects.Value = ino++;
                     ProgressSalesProjects.Update();
                 }
                 // 行や列を追加したり、セルに値を設定するときは、自動サイズ設定しない。
-                dgvSalesInProjects.AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.None;
-                dgvSalesInProjects.AutoSizeRowsMode = DataGridViewAutoSizeRowsMode.None;
-                dgvSalesInProjects.ColumnHeadersHeightSizeMode = DataGridViewColumnHeadersHeightSizeMode.DisableResizing;
+                dgv.AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.None;
+                dgv.AutoSizeRowsMode = DataGridViewAutoSizeRowsMode.None;
+                dgv.ColumnHeadersHeightSizeMode = DataGridViewColumnHeadersHeightSizeMode.DisableResizing;
 
                 // ProgressBarの値を変更する
                 ProgressSalesProjects.Value = ProgressSalesProjects.Maximum;
@@ -1351,18 +1400,18 @@
             finally
             {
                 // データが多くなればソートできる
-                if (CommonDefine.s_MaxInitLineCount > dgvSalesInProjects.RowCount)
-                    dgvSalesInProjects.RowCount += (CommonDefine.s_MaxInitLineCount - dgvSalesInProjects.RowCount);
+                if (CommonDefine.s_MaxInitLineCount > dgv.RowCount)
+                    dgv.RowCount += (CommonDefine.s_MaxInitLineCount - dgv.RowCount);
 
                 // データが多くなればソートできる
-                foreach (DataGridViewColumn wrkCol in dgvSalesInProjects.Columns)
+                foreach (DataGridViewColumn wrkCol in dgv.Columns)
                     wrkCol.SortMode = DataGridViewColumnSortMode.Automatic;
 
                 // グリッドソート実行
-                GridSortExcute(dgvSalesInProjects);
+                GridSortExcute(dgv);
                 ChkProc = null;
                 cbiDB.close(); cbiDB = null;
-                dgvSalesInProjects.ResumeLayout();
+                dgv.ResumeLayout();
             }
         }
         #endregion
@@ -1379,6 +1428,7 @@
                 List<int> stat = new List<int>();
                 stat.Add((int)CommonDefine.BaseInfoEstimateType.Normal);
 
+                strSQL += CreateListSQLFluctuation();
                 strSQL += CreateListSQL(stat, true);
 
                 return strSQL;
@@ -1401,15 +1451,20 @@
         {
             ClsSystemOnceExecute ChkProc = new ClsSystemOnceExecute();
             IOConstructionBaseInfo cbiDB = new IOConstructionBaseInfo();
-            dgvTenders.SuspendLayout();
+            DataGridViewEX dgv = dgvTenders;
             try
             {
-                dgvTenders.Rows.Clear();
+                dgv.SuspendLayout();
+                dgv.Rows.Clear();
                 // SQL作成
                 string strSQL = "SELECT A.ConstructionCode, A.ConstructionPeriod, B.DETAILNO, B.DETAILSTRING, A.ConstructionStatusFlg,";
-                strSQL += " A.EstimatesSubmitDeadline, C.PERSONNAME, D.PERSONNAME, A.STARTDATE, A.ENDDATE, A.* ";
-                strSQL += " FROM CONSTRUCTIONBASEINFO A LEFT JOIN  PERSONINCHARGEMASTER D  ON D.PERSONCODE = A.CONSTRUCTIONPERSONCODE,";
-                strSQL += " CONSTRUCTIONBASEINFODETAIL B , PERSONINCHARGEMASTER C";
+                strSQL += " A.EstimatesSubmitDeadline, C.PERSONNAME, D.PERSONNAME, A.STARTDATE, A.ENDDATE, G.APPROVALCODE, NVL(G.APPROVALSTATUS, -1), A.*";
+                strSQL += " FROM CONSTRUCTIONBASEINFO A";
+                strSQL += " LEFT JOIN  PERSONINCHARGEMASTER D  ON D.PERSONCODE = A.CONSTRUCTIONPERSONCODE";
+                strSQL += " LEFT JOIN (SELECT SG.CONSTRUCTIONCODE, SG.SEQNO, SG.APPROVALSTATUS, MAX(SG.APPROVALCODE) APPROVALCODE";
+                strSQL += " FROM PROCESSAPPROVAL SG GROUP BY SG.CONSTRUCTIONCODE, SG.SEQNO, SG.APPROVALSTATUS) G";
+                strSQL += " ON A.ConstructionCode = G.CONSTRUCTIONCODE AND G.SEQNO = 1";
+                strSQL += ", CONSTRUCTIONBASEINFODETAIL B , PERSONINCHARGEMASTER C";
 
                 strSQL += CreateTendersSQL();
                 strSQL += string.Format(" AND B.CONSTRUCTIONCODE = A.CONSTRUCTIONCODE AND B.DETAILNO <= {0}", (int)ConstructionBaseInfoDetail.DetailDataNo.ConstructionPlace3);
@@ -1450,6 +1505,11 @@
                     DateTime dStartDate = CommonMotions.cnvDate(wrkRec[(int)DBColumn1.STARTDATE]);
                     DateTime dEndDate = CommonMotions.cnvDate(wrkRec[(int)DBColumn1.ENDDATE]);
 
+                    int iApprovalCode = CommonMotions.cnvInt(wrkRec[(int)DBColumn1.ApprovalCode]);
+                    string sApprovalName = string.Empty;
+                    if (iApprovalCode != 0) sApprovalName = ClsExcute.AppovalList[iApprovalCode];
+                    int iApprovalStatus = CommonMotions.cnvInt(wrkRec[(int)DBColumn1.ApprovalSTatus]);
+
                     if (iConstructionCode == BreakConstructionCode) continue;
                     // 名称取得
                     getDetailStrings(iConstructionCode, arData, ref Details);
@@ -1460,16 +1520,17 @@
                     if (BreakConstructionPeriod != iConstructionPeriod)
                     {
                         BreakConstructionPeriod = iConstructionPeriod;
-                        dgvTenders.Rows.Add();
+                        dgv.Rows.Add();
                         iLineCnt++;
                     }
 
                     // データセット
-                    int LineCnt = dgvTenders.Rows.Add(iConstructionCode
+                    int LineCnt = dgv.Rows.Add(iConstructionCode
                                                 , ino
                                                 , iConstructionPeriod
                                                 , Details[0]
                                                 , CommonDefine.ProjectsStatus[iConstructionStatusFlg]
+                                                , sApprovalName
                                                 , CommonMotions.cnvDateToUndecidedString(dEstimatesSubmitDeadline)
                                                 , salesname
                                                 , constructorname
@@ -1490,17 +1551,21 @@
 
                     // エラー行に色を付ける
                     DataGridViewRow row = dgvSalesInProjects.Rows[LineCnt];
-                    DispErrorSubmittedDateRow(dgvTenders, row, BaseRec, ChkProc);
+                    DispErrorSubmittedDateRow(dgv, row, BaseRec, ChkProc);
                     iLineCnt++;
-                    
+
+                    // 承認状態に色を付ける
+                    DataGridViewCell CurCell = dgv.Rows[LineCnt].Cells[(int)MenuGridCount.ConstrApproval];
+                    SetCellApprovalColor(CurCell, iApprovalCode, iApprovalStatus);
+
                     // ProgressBarの値を変更する
                     ProgressTenders.Value = ino++;
                     ProgressTenders.Update();
                 }
                 // 行や列を追加したり、セルに値を設定するときは、自動サイズ設定しない。
-                dgvTenders.AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.None;
-                dgvTenders.AutoSizeRowsMode = DataGridViewAutoSizeRowsMode.None;
-                dgvTenders.ColumnHeadersHeightSizeMode = DataGridViewColumnHeadersHeightSizeMode.DisableResizing;
+                dgv.AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.None;
+                dgv.AutoSizeRowsMode = DataGridViewAutoSizeRowsMode.None;
+                dgv.ColumnHeadersHeightSizeMode = DataGridViewColumnHeadersHeightSizeMode.DisableResizing;
 
                 // ProgressBarの値を変更する
                 ProgressTenders.Value = ProgressTenders.Maximum;
@@ -1514,18 +1579,18 @@
             finally
             {
                 // 読込時データカウント取得
-                if (CommonDefine.s_MaxInitLineCount > dgvTenders.RowCount)
-                    dgvTenders.RowCount += (CommonDefine.s_MaxInitLineCount - dgvTenders.RowCount);
+                if (CommonDefine.s_MaxInitLineCount > dgv.RowCount)
+                    dgv.RowCount += (CommonDefine.s_MaxInitLineCount - dgv.RowCount);
 
                 // ソートできる
-                foreach (DataGridViewColumn wrkCol in dgvTenders.Columns)
+                foreach (DataGridViewColumn wrkCol in dgv.Columns)
                     wrkCol.SortMode = DataGridViewColumnSortMode.Automatic;
 
                 // グリッドソート実行
-                GridSortExcute(dgvTenders);
+                GridSortExcute(dgv);
                 ChkProc = null;
                 cbiDB.close(); cbiDB = null;
-                dgvTenders.ResumeLayout();
+                dgv.ResumeLayout();
             }
         }
         #endregion
@@ -1542,6 +1607,7 @@
                 List<int> stat = new List<int>();
                 stat.Add((int)CommonDefine.BaseInfoEstimateType.Didding);
 
+                strSQL += CreateListSQLFluctuation();
                 strSQL += CreateListSQL(stat, true);
 
                 return strSQL;
@@ -1564,15 +1630,20 @@
         {
             ClsSystemOnceExecute ChkProc = new ClsSystemOnceExecute();
             IOConstructionBaseInfo cbiDB = new IOConstructionBaseInfo();
-            dgvBudgetUp.SuspendLayout();
+            DataGridViewEX dgv = dgvBudgetUp;
             try
             {
-                dgvBudgetUp.Rows.Clear();
+                dgv.SuspendLayout();
+                dgv.Rows.Clear();
                 // SQL作成
                 string strSQL = "SELECT A.ConstructionCode, A.ConstructionPeriod, B.DETAILNO, B.DETAILSTRING, A.ConstructionStatusFlg,";
-                strSQL += " A.EstimatesSubmitDeadline, C.PERSONNAME, D.PERSONNAME, A.STARTDATE, A.ENDDATE, A.* ";
-                strSQL += " FROM CONSTRUCTIONBASEINFO A LEFT JOIN  PERSONINCHARGEMASTER D  ON D.PERSONCODE = A.CONSTRUCTIONPERSONCODE,";
-                strSQL += " CONSTRUCTIONBASEINFODETAIL B , PERSONINCHARGEMASTER C";
+                strSQL += " A.EstimatesSubmitDeadline, C.PERSONNAME, D.PERSONNAME, A.STARTDATE, A.ENDDATE, G.APPROVALCODE, NVL(G.APPROVALSTATUS, -1), A.*";
+                strSQL += " FROM CONSTRUCTIONBASEINFO A";
+                strSQL += " LEFT JOIN  PERSONINCHARGEMASTER D  ON D.PERSONCODE = A.CONSTRUCTIONPERSONCODE";
+                strSQL += " LEFT JOIN (SELECT SG.CONSTRUCTIONCODE, SG.SEQNO, SG.APPROVALSTATUS, MAX(SG.APPROVALCODE) APPROVALCODE";
+                strSQL += " FROM PROCESSAPPROVAL SG GROUP BY SG.CONSTRUCTIONCODE, SG.SEQNO, SG.APPROVALSTATUS) G";
+                strSQL += " ON A.ConstructionCode = G.CONSTRUCTIONCODE AND G.SEQNO = 1";
+                strSQL += ", CONSTRUCTIONBASEINFODETAIL B , PERSONINCHARGEMASTER C";
 
                 strSQL += CreateBudgetUpProjectsSQL();
                 strSQL += string.Format(" AND B.CONSTRUCTIONCODE = A.CONSTRUCTIONCODE AND B.DETAILNO <= {0}", (int)ConstructionBaseInfoDetail.DetailDataNo.ConstructionPlace3);
@@ -1613,6 +1684,11 @@
                     DateTime dStartDate = CommonMotions.cnvDate(wrkRec[(int)DBColumn1.STARTDATE]);
                     DateTime dEndDate = CommonMotions.cnvDate(wrkRec[(int)DBColumn1.ENDDATE]);
 
+                    int iApprovalCode = CommonMotions.cnvInt(wrkRec[(int)DBColumn1.ApprovalCode]);
+                    string sApprovalName = string.Empty;
+                    if (iApprovalCode != 0) sApprovalName = ClsExcute.AppovalList[iApprovalCode];
+                    int iApprovalStatus = CommonMotions.cnvInt(wrkRec[(int)DBColumn1.ApprovalSTatus]);
+
                     if (iConstructionCode == BreakConstructionCode) continue;
                     // 名称取得
                     getDetailStrings(iConstructionCode, arData, ref Details);
@@ -1623,16 +1699,17 @@
                     if (BreakConstructionPeriod != iConstructionPeriod)
                     {
                         BreakConstructionPeriod = iConstructionPeriod;
-                        dgvBudgetUp.Rows.Add();
+                        dgv.Rows.Add();
                         iLineCnt++;
                     }
 
                     // データセット
-                    int LineCnt = dgvBudgetUp.Rows.Add(iConstructionCode
+                    int LineCnt = dgv.Rows.Add(iConstructionCode
                                                 , ino
                                                 , iConstructionPeriod
                                                 , Details[0]
                                                 , CommonDefine.ProjectsStatus[iConstructionStatusFlg]
+                                                , sApprovalName
                                                 , CommonMotions.cnvDateToUndecidedString(dEstimatesSubmitDeadline)
                                                 , salesname
                                                 , constructorname
@@ -1653,17 +1730,21 @@
 
                     // エラー行に色を付ける
                     DataGridViewRow row = dgvSalesInProjects.Rows[LineCnt];
-                    DispErrorSubmittedDateRow(dgvBudgetUp, row, BaseRec, ChkProc);
+                    DispErrorSubmittedDateRow(dgv, row, BaseRec, ChkProc);
                     iLineCnt++;
 
+                    // 承認状態に色を付ける
+                    DataGridViewCell CurCell = dgv.Rows[LineCnt].Cells[(int)MenuGridCount.ConstrApproval];
+                    SetCellApprovalColor(CurCell, iApprovalCode, iApprovalStatus);
+
                     // ProgressBarの値を変更する
                     ProgressBudgetUp.Value = ino++;
                     ProgressBudgetUp.Update();
                 }
                 // 行や列を追加したり、セルに値を設定するときは、自動サイズ設定しない。
-                dgvBudgetUp.AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.None;
-                dgvBudgetUp.AutoSizeRowsMode = DataGridViewAutoSizeRowsMode.None;
-                dgvBudgetUp.ColumnHeadersHeightSizeMode = DataGridViewColumnHeadersHeightSizeMode.DisableResizing;
+                dgv.AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.None;
+                dgv.AutoSizeRowsMode = DataGridViewAutoSizeRowsMode.None;
+                dgv.ColumnHeadersHeightSizeMode = DataGridViewColumnHeadersHeightSizeMode.DisableResizing;
 
                 // ProgressBarの値を変更する
                 ProgressBudgetUp.Value = ProgressBudgetUp.Maximum;
@@ -1677,19 +1758,19 @@
             finally
             {
                 // データが多くなればソートできる
-                if (CommonDefine.s_MaxInitLineCount > dgvBudgetUp.RowCount)
-                    dgvBudgetUp.RowCount += (CommonDefine.s_MaxInitLineCount - dgvBudgetUp.RowCount);
+                if (CommonDefine.s_MaxInitLineCount > dgv.RowCount)
+                    dgv.RowCount += (CommonDefine.s_MaxInitLineCount - dgv.RowCount);
 
                 // 読込時データカウント取得
-                foreach (DataGridViewColumn wrkCol in dgvBudgetUp.Columns)
+                foreach (DataGridViewColumn wrkCol in dgv.Columns)
                     wrkCol.SortMode = DataGridViewColumnSortMode.Automatic;
 
                 // グリッドソート実行
-                GridSortExcute(dgvBudgetUp);
+                GridSortExcute(dgv);
 
                 ChkProc = null;
                 cbiDB.close(); cbiDB = null;
-                dgvBudgetUp.ResumeLayout();
+                dgv.ResumeLayout();
             }
         }
         #endregion
@@ -1706,6 +1787,7 @@
                 List<int> stat = new List<int>();
                 stat.Add((int)CommonDefine.BaseInfoEstimateType.GetBudget);
 
+                strSQL += CreateListSQLFluctuation();
                 strSQL += CreateListSQL(stat, true);
 
                 return strSQL;
@@ -1737,6 +1819,8 @@
             CS_PERSONNAME,
             I_PERSONNAME,
             DepartmentCode,
+            ApprovalCode,
+            ApprovalSTatus,
         }
         #endregion
 
@@ -1749,17 +1833,23 @@
             ClsSystemOnceExecute ChkProc = new ClsSystemOnceExecute();
             IOConstructionBaseInfo cbiDB = new IOConstructionBaseInfo();
             IOMDepartment dmDB = new IOMDepartment();
-            dgvConstructionProjects.SuspendLayout();
+            DataGridViewEX dgv = dgvConstructionProjects;
             try
             {
-                dgvConstructionProjects.Rows.Clear();
+                dgv.SuspendLayout();
+
+                dgv.Rows.Clear();
                 // SQL作成
                 string strSQL = "SELECT A.ConstructionCode, A.ConstructionPeriod, B.DETAILNO, B.DETAILSTRING, A.ConstructionStatusFlg,";
-                strSQL += " A.EstimatesSubmitDeadline, C.PERSONNAME, D.PERSONNAME, E.PERSONNAME, F.PERSONNAME, D.DepartmentCode , A.*";
-                strSQL += " FROM (CONSTRUCTIONBASEINFO A LEFT JOIN PERSONINCHARGEMASTER D ON D.PERSONCODE = A.CONSTRUCTIONPERSONCODE)";
+                strSQL += " A.EstimatesSubmitDeadline, C.PERSONNAME, D.PERSONNAME, E.PERSONNAME, F.PERSONNAME, D.DepartmentCode,";
+                strSQL += " G.APPROVALCODE, NVL(G.APPROVALSTATUS, -1), A.*";
+                strSQL += " FROM CONSTRUCTIONBASEINFO A LEFT JOIN PERSONINCHARGEMASTER D ON D.PERSONCODE = A.CONSTRUCTIONPERSONCODE";
                 strSQL += " LEFT JOIN PERSONINCHARGEMASTER E ON E.PERSONCODE = A.CONSTRSUBPERSONCODE";
-                strSQL += " LEFT JOIN PERSONINCHARGEMASTER F ON E.PERSONCODE = A.CONSTRUCTIONINSTRUCTOR";
-                strSQL += " , CONSTRUCTIONBASEINFODETAIL B, PERSONINCHARGEMASTER C";
+                strSQL += " LEFT JOIN PERSONINCHARGEMASTER F ON F.PERSONCODE = A.CONSTRUCTIONINSTRUCTOR";
+                strSQL += " LEFT JOIN (SELECT SG.CONSTRUCTIONCODE, SG.SEQNO, SG.APPROVALSTATUS, MAX(SG.APPROVALCODE) APPROVALCODE";
+                strSQL += " FROM PROCESSAPPROVAL SG GROUP BY SG.CONSTRUCTIONCODE, SG.SEQNO, SG.APPROVALSTATUS) G";
+                strSQL += " ON A.ConstructionCode = G.CONSTRUCTIONCODE AND G.SEQNO = 1";
+                strSQL += ", CONSTRUCTIONBASEINFODETAIL B, PERSONINCHARGEMASTER C";
 
                 strSQL += CreateConstructionProjectsSQL();
 
@@ -1771,8 +1861,20 @@
                 ArrayList arData = new ArrayList();
 
                 // 工事基本情報取得
-                if (!cbiDB.ExecuteReader(strSQL, ref arData)) return;
-                if (arData.Count == 0) return;
+                if (!cbiDB.ExecuteReader(strSQL, ref arData))
+                {
+                    lblPeriod.Visible = false;
+                    numUDConstPro.Visible = false;
+                    return;
+                }
+                if (arData.Count == 0)
+                {
+                    lblPeriod.Visible = false;
+                    numUDConstPro.Visible = false;
+                    return;
+                }
+                lblPeriod.Visible = true;
+                numUDConstPro.Visible = true;
 
                 ProgressConstructionProjects.Visible = true;
                 ProgressConstructionProjects.Minimum = 0;
@@ -1803,14 +1905,9 @@
                 else
                     numUDConstPro.Value = maxval;
 
-                // 期数を取得する
-                int BlankCnt = GetPeriodCount(strPeriod) - 1;
-                // 行を作成する
-                DataGridViewRow[] list = new DataGridViewRow[arData.Count + BlankCnt];
-
                 // 先頭の期数を取得する
                 object[] firstwrkRec = (object[])arData[0];
-                int BreakConstructionPeriod = CommonMotions.cnvInt(firstwrkRec[(int)DBColumn1.ConstructionPeriod]);
+                int BreakConstructionPeriod = CommonMotions.cnvInt(firstwrkRec[(int)DBColumn2.ConstructionPeriod]);
                 int iLineCnt = 0;
                 int DBCnt = Enum.GetNames(typeof(DBColumn2)).Length;
                 int BreakConstructionCode = 0;
@@ -1820,14 +1917,27 @@
                     int iConstructionPeriod = CommonMotions.cnvInt(DataRec[(int)DBColumn2.ConstructionPeriod]);
                     int iConstructionStatusFlg = CommonMotions.cnvInt(DataRec[(int)DBColumn2.ConstructionStatusFlg]);
                     DateTime dEstimatesSubmitDeadline = CommonMotions.cnvDate(DataRec[(int)DBColumn2.EstimatesSubmitDeadline]);
+
                     string salesname = CommonMotions.cnvString(DataRec[(int)DBColumn2.S_PERSONNAME]);
+                    
                     string constructorname = CommonMotions.cnvString(DataRec[(int)DBColumn2.C_PERSONNAME]);
                     if (constructorname.Length == 0) constructorname = CommonDefine.s_UndecidedString;
+
                     string instructorname = CommonMotions.cnvString(DataRec[(int)DBColumn2.I_PERSONNAME]);
-                    if (instructorname.Length == 0) instructorname = CommonDefine.s_UndecidedString;
+                    //if (instructorname.Length == 0) instructorname = CommonDefine.s_UndecidedString;
+
+                    string subconstr = CommonMotions.cnvString(DataRec[(int)DBColumn2.CS_PERSONNAME]);
+                    //if (subconstr.Length == 0) subconstr = CommonDefine.s_UndecidedString;
+
                     int iDepartmentCode = CommonMotions.cnvInt(DataRec[(int)DBColumn2.DepartmentCode]);
+                    
+                    int iApprovalCode = CommonMotions.cnvInt(DataRec[(int)DBColumn2.ApprovalCode]);
+                    string sApprovalName = string.Empty;
+                    if (iApprovalCode != 0) sApprovalName = ClsExcute.AppovalList[iApprovalCode];
+                    int iApprovalStatus = CommonMotions.cnvInt(DataRec[(int)DBColumn2.ApprovalSTatus]);
 
                     if (iConstructionCode == BreakConstructionCode) continue;
+                    
                     // 名称取得
                     getDetailStrings(iConstructionCode, arData, ref Details);
 
@@ -1848,7 +1958,7 @@
                     if (BreakConstructionPeriod != wrkRec.ConstructionPeriod)
                     {
                         BreakConstructionPeriod = wrkRec.ConstructionPeriod;
-                        dgvConstructionProjects.Rows.Add();
+                        dgv.Rows.Add();
                         iLineCnt++;
                     }
                     string jyutyu = "";
@@ -1857,25 +1967,31 @@
                     int iStatusFlg = wrkRec.ConstructionStatusFlg;
 
                     // データセット
-                    int LineCnt = dgvConstructionProjects.Rows.Add(wrkRec.ConstructionCode
+                    int LineCnt = dgv.Rows.Add(wrkRec.ConstructionCode
                                                 , ino
                                                 , wrkRec.ConstructionPeriod
                                                 , Details[0]
                                                 , CommonDefine.ProjectsStatus[iStatusFlg]
+                                                , sApprovalName
                                                 , salesname
                                                 , constructorname
-                                                , instructorname
                                                 , CommonMotions.cnvDateToUndecidedString(wrkRec.OrderStartingDate)
                                                 , CommonMotions.cnvDateToUndecidedString(wrkRec.OrderCompletionDate)
+                                                , instructorname
+                                                , subconstr
                                                 , Details[1] + Details[2] + Details[3]
                                                 , Details[4]
                                                 , jyutyu );
 
                     // エラー行に色を付ける
-                    DataGridViewRow row = dgvConstructionProjects.Rows[LineCnt];
-                    DispErrorSubmittedDateRow(dgvConstructionProjects, row, wrkRec, ChkProc);
+                    DataGridViewRow row = dgv.Rows[LineCnt];
+                    DispErrorSubmittedDateRow(dgv, row, wrkRec, ChkProc);
                     iLineCnt++;
 
+                    // 承認状態に色を付ける
+                    DataGridViewCell CurCell = dgv.Rows[LineCnt].Cells[(int)MenuGridCount.ConstrApproval];
+                    SetCellApprovalColor(CurCell, iApprovalCode, iApprovalStatus, false);
+
                     // ProgressBarの値を変更する
                     ProgressConstructionProjects.Value = ino++;
                     ProgressConstructionProjects.Update();
